<?php
/* $header$ */

#   
function nc_tag_add($Sub_ID, $Sub_Class_ID, $Message_ID, $tags_string) {
global $db;

	$date = date('Y-m-d H:i:s');
	$Sub_ID = (int)$Sub_ID;
	$Sub_Class_ID = (int)$Sub_Class_ID;
	$Message_ID = (int)$Message_ID;

	$tags = explode(",", $tags_string);
	$tags = array_unique($tags);
	//   
	if($tags)
	foreach ($tags AS $key => $value) {
		$tag = $db->escape( trim($value) );
		//  ,    
		$exist_tag_ID = $db->get_var("SELECT Tag_ID FROM Tags_Data WHERE Tag_Text='".$tag."'");
		if($exist_tag_ID) {
			//      ,   	
			$exist_tag_ID_weight = $db->get_var("SELECT Tag_ID FROM Tags_Weight WHERE Tag_ID=".$exist_tag_ID." AND Sub_Class_ID=".$Sub_Class_ID."");
			if($exist_tag_ID_weight)
				//   
				$db->query("UPDATE Tags_Weight SET Tag_Weight=Tag_Weight+1 WHERE Tag_ID=".$exist_tag_ID." AND Sub_Class_ID=".$Sub_Class_ID."");
			else 
				//   
				$db->query("INSERT INTO Tags_Weight (Tag_ID, Sub_Class_ID, Tag_Weight) VALUES (".$exist_tag_ID.", ".$Sub_Class_ID.", 1)");
		}
		else {
			//   ,    
			$db->query("INSERT INTO Tags_Data (Tag_Text) VALUES ('".$tag."')");
			$tag_ID = $db->insert_id;
			//   
			$db->query("INSERT INTO Tags_Weight (Tag_ID, Sub_Class_ID, Tag_Weight) VALUES (".$tag_ID.", ".$Sub_Class_ID.", 1)");
		}
		//     
		$db->query("INSERT INTO Tags_Message (Tag_ID, Sub_Class_ID, Message_ID) VALUES (".(int)($exist_tag_ID ? $exist_tag_ID : $tag_ID).", ".$Sub_Class_ID.", ".$Message_ID.")");
	}
}

#   
function nc_tag_edit() {

}

#   
function nc_tag_drop($Sub_Class_ID, $Message_ID, $tag="") {
global $db;
	
	$Sub_Class_ID = (int)$Sub_Class_ID;
	$Message_ID = (int)$Message_ID;

	//   ID   
	$tags_IDs = $db->get_col("SELECT Tag_ID FROM Tags_Message WHERE Sub_Class_ID=".$Sub_Class_ID." AND Message_ID=".$Message_ID."");

	//   
	if($tags_IDs) {
		$tags_IDs_str = join(",", $tags_IDs);
		//      
		$db->query("DELETE FROM Tags_Message WHERE Sub_Class_ID=".$Sub_Class_ID." AND Message_ID=".$Message_ID."");
		//  
		$db->query("UPDATE Tags_Weight SET Tag_Weight=Tag_Weight-1 WHERE Tag_ID IN (".$tags_IDs_str.") AND Sub_Class_ID=".$Sub_Class_ID."");
		//     
		$db->query("DELETE FROM Tags_Weight WHERE Tag_Weight<=0");
	}
	
	//   ID      
	$tags_IDs_diff = $db->get_col("SELECT Tag_ID FROM Tags_Message WHERE Tag_ID IN (".$tags_IDs_str.")");
	//  
	if($tags_IDs_diff) $tags_diff_array = array_diff($tags_IDs, $tags_IDs_diff);

	//         
	if($tags_diff_array) {
		$tags_IDs_diff_str = join(",", $tags_diff_array);
		$db->query("DELETE FROM Tags_Data WHERE Tag_ID IN (".$tags_IDs_diff_str.")");
	}
}

#  
function Tag_Size($Value, $Max, $Min, $Sum) {
global $MODULE_VARS;
	
	$maxFont = $MODULE_VARS['tagscloud']['MAX_FONT'];
	$minFont = $MODULE_VARS['tagscloud']['MIN_FONT'];
	$fontrange = $maxFont - $minFont;
	//  
	$px = min($fontrange, ($Value-$Min)/max(1, $Max-$Min) * $fontrange);
		
return $minFont + round($px);
}

#    
function nc_tag_cloud($Sub_Class_ID, $design, $adress_str="", $quantity="") {
global $db, $MODULE_VARS;
	
	$Sub_Class_ID = (array)$Sub_Class_ID;
	$sql_where = join(",", $Sub_Class_ID);
	if($quantity) $quantity_limit = $quantity; else $quantity_limit = $MODULE_VARS['tagscloud']['QUANTITY'];

	//    
	$tags_array = $db->get_results("SELECT T.`Tag_Text`, T.`Tag_ID`, SUM(W.`Tag_Weight`) AS Tag_Count
		FROM `Tags_Weight` AS W
		LEFT JOIN `Tags_Data` AS T ON T.`Tag_ID` = W.`Tag_ID` 
		WHERE W.`Sub_Class_ID` IN (".$sql_where.")
		GROUP BY T.`Tag_ID`
		ORDER BY `Tag_Count` DESC
		LIMIT ".$quantity_limit."", ARRAY_A);

	if($tags_array) {
		//      - Tag_Text
		sort($tags_array);	
		
		//    
		$Max_Count = $Min_Count = $tags_array[0]['Tag_Count'];
		foreach ($tags_array AS $value) {
			if($value['Tag_Count'] > $Max_Count) $Max_Count = $value['Tag_Count'];
			if($value['Tag_Count'] < $Min_Count) $Min_Count = $value['Tag_Count'];
		}

		//   
		$Sum_Count = 0;
		foreach ( $tags_array AS $key => $value) {
			$Sum_Count = $Sum_Count + $value['Tag_Count'];
		}
		
		$cloud = "";
		//  
		$i = 0; while( $i<count($tags_array) ) {
			$temp_cloud="";	
			$Tag_Size = Tag_Size($tags_array[$i]['Tag_Count'], $Max_Count, $Min_Count, $Sum_Count);
			//   
			$temp_cloud = str_replace("%TAG_HEIGHT", $Tag_Size, $design);
			$temp_cloud = str_replace("%TAG_LINK", "?tag=".$tags_array[$i]['Tag_ID'], $temp_cloud);
			$temp_cloud = str_replace("%TAG_SUB_LINK", $adress_str, $temp_cloud);
			$temp_cloud = str_replace("%TAG_NAME", $db->escape($tags_array[$i]['Tag_Text']), $temp_cloud);
			eval("\$cloud.=\"$temp_cloud\";"); 
			//  
			if( (count($tags_array)-1)!=$i ) $cloud.=" ";
		++$i;
		}
	}
	
return $cloud;
}

#      
function nc_tag_cloud_all($site_ID="", $design, $quantity="") {
global $db;

	$quantity = (int)$quantity;
		
	//      
	if($site_ID) {
		$site_ID = (array)$site_ID;
		$site_ID = array_map("intval", $site_ID);
		$SQL_where_str = "WHERE Catalogue_ID IN (". join(',', $site_ID)  .")";
	}
	
	//   
	$Sub_Class_ID = $db->get_col("SELECT Sub_Class_ID FROM Sub_Class ".$SQL_where_str);
	
	// CLOUD
	$cloud = nc_tag_cloud($Sub_Class_ID, $design, "", max(0,$quantity));

return $cloud;
}

#      Subdivision_ID ( mixed )
function nc_tag_cloud_subdivision($Sub_ID, $design, $quantity="") {
global $db;

	if(!$Sub_ID) return false;
	else {
		$Sub_ID = (array)$Sub_ID;
		$Sub_ID = array_map("intval", $Sub_ID);
	}
	$quantity = (int)$quantity;

	//     
	$adress_str = "";
	if(count($Sub_ID)>1) {
		foreach($Sub_ID AS $key => $value) {
			$sym = "&amp;";
			$adress_str .= $sym."tagsub[".$key."]=".$value;
		}
	}
	else $adress_str = "&amp;tagsub=".$Sub_ID[0];
	
	//    
	$subArray = $Sub_ID;
	while( $tSub = $db->get_col("SELECT Subdivision_ID FROM Subdivision WHERE Parent_Sub_ID IN (".join(",", $Sub_ID).")") ) {
		$subArray = array_merge($subArray, $tSub);
		$Sub_ID = $tSub;
	}
	//    ,  ..  
	$sql_where = join(",", $subArray);

	//   
	$Sub_Class_ID = $db->get_col("SELECT Sub_Class_ID FROM Sub_Class WHERE Subdivision_ID IN (".$sql_where.")");

	// CLOUD
	$cloud = nc_tag_cloud($Sub_Class_ID, $design, $adress_str, max(0,$quantity));

return $cloud;
}

#        Sub_Class_ID ( mixed )
function nc_tag_cloud_sub_class($Sub_Class_ID, $design, $quantity="") {
global $db;

	if(!$Sub_Class_ID) return false;
	else {
		$Sub_Class_ID = (array)$Sub_Class_ID;
		$Sub_Class_ID = array_map("intval", $Sub_Class_ID);
	}
	$quantity = (int)$quantity;
	
	//     
	$adress_str = "";
	if(count($Sub_Class_ID)>1) {
		foreach($Sub_Class_ID AS $key => $value) {
			$sym = "&amp;";
			$adress_str .= $sym."tagcc[".$key."]=".$value;
		}
	}
	else $adress_str = "&amp;tagcc=".$Sub_Class_ID[0];
	
	// CLOUD
	$cloud = nc_tag_cloud($Sub_Class_ID, $design, $adress_str, max(0,$quantity));

return $cloud;
}

#      ,    
/*
$tag - ID 
$sub - ID 
$cc -   
*/
function nc_tag_cloud_show_result($tag, $sub="", $cc="") {
global $db;

	$tag = (int)$tag;
	if($sub) {
		$sub = (array)$sub;
		$sub = array_map("intval", $sub);
	}
	if($cc) {
		$cc = (array)$cc;
		$cc = array_map("intval", $cc);
	}
	if(!$tag && !$sub && !$cc) return false;

	//        
	if($sub) {
		//    
		$subArray = $sub;
		while( $tSub = $db->get_col("SELECT Subdivision_ID FROM Subdivision WHERE Parent_Sub_ID IN (".join(",", $sub).")") ) {
			$subArray = array_merge($subArray, $tSub);
			$sub = $tSub;
		}
		//    ,  ..  
		$sql_where = join(",", $subArray);
	
		$Sub_Classes = $db->get_col("SELECT DISTINCT Sub_Class_ID FROM Sub_Class WHERE Subdivision_ID IN (".$sql_where.")");
		if($Sub_Classes) $sql_where = join(",", $Sub_Classes); else return false;
	}
	elseif($cc) {
		$sql_where = join(",", $cc);
	}
	else {
		$Sub_Classes = $db->get_col("SELECT DISTINCT Sub_Class_ID FROM Tags_Message WHERE Tag_ID=".$tag."");
		if($Sub_Classes) $sql_where = join(",", $Sub_Classes); else return false;
	}

	if($sql_where)
	$res = $db->get_results("SELECT sc.Subdivision_ID, s.Subdivision_Name, sc.Sub_Class_ID, ts.Message_ID
							FROM (Sub_Class AS sc, Tags_Message AS ts)
							LEFT JOIN Subdivision AS s ON sc.Subdivision_ID=s.Subdivision_ID
							WHERE sc.Sub_Class_ID IN (".$sql_where.") AND sc.Sub_Class_ID=ts.Sub_Class_ID AND ts.Tag_ID=".$tag."
							ORDER BY sc.Subdivision_ID, sc.Sub_Class_ID, ts.Message_ID DESC", ARRAY_A);

	//           ,  
	// $messages_array -    - CC_ID,  -  Message_ID
	if($res)
	foreach($res AS $key => $value) {
		$messages_array[] = array("Subdivision_ID" => $value['Subdivision_ID'],
								  "Subdivision_Name" => $value['Subdivision_Name'],
								  "Sub_Class_ID" => $value['Sub_Class_ID'],
								  "Message_ID" => $value['Message_ID']);
	}

	//  
	$tagText = $db->get_var("SELECT Tag_Text FROM Tags_Data WHERE Tag_ID=".$tag."");

return array($messages_array, $tagText);
}
?>