<?
/* $Id: CheckUserFunctions.inc.php 1969 2008-04-16 10:11:12Z zb3k $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");

require_once ($ADMIN_FOLDER.'consts.inc.php');
require_once ($ADMIN_FOLDER.'auth.inc.php');
require_once ($ADMIN_FOLDER.'user.inc.php');
require_once ($ADMIN_FOLDER.'sub_class.inc.php');
require_once ($ADMIN_FOLDER.'subdivision.inc.php');
require_once ($ADMIN_FOLDER.'mail.inc.php');


/**
  *     
  * @return array Element[English.php] = English 
  */
function Language_Show() {
  global $ADMIN_FOLDER;
  if ($handle = opendir($ADMIN_FOLDER."lang")) {
    $lang=array();
    while (false !== ($file = readdir($handle))) {
      if (strlen($file)>4) {
        $name=explode(".", $file);
        $lang[$file]=$name[0];
      }
    }
    closedir($handle);
    return($lang);
  } else {
    return(false);
  }
}


function NetCat_language_detect($lang='') {
    
	global $_SERVER, $ADMIN_LANGUAGE;

    $langtable = array(
    'af' => 'Afrikaans',
    'sq' => 'Albanian',
    'ar' => 'Arabic',
    'hy' => 'Armenian',
    'as' => 'Assamese',
    'az' => 'Azeri',
    'eu' => 'Basque',
    'be' => 'Belarusian',
    'bn' => 'Bengali',
    'bg' => 'Bulgarian',
    'ca' => 'Catalan',
    'zh' => 'Chinese',
    'hr' => 'Croatian',
    'cs' => 'Chech',
    'da' => 'Danish',
    'div' => 'Divehi',
    'nl' => 'Dutch',
    'en' => 'English',
    'et' => 'Estonian',
    'fo' => 'Faeroese',
    'fa' => 'Farsi',
    'fi' => 'Finnish',
    'fr' => 'French',
    'mk' => 'FYRO Macedonian',
    'gd' => 'Gaelic',
    'ka' => 'Georgian',
    'de' => 'German',
    'el' => 'Greek',
    'gu' => 'Gujarati',
    'he' => 'Hebrew',
    'hi' => 'Hindi',
    'hu' => 'Hungarian',
    'is' => 'Icelandic',
    'id' => 'Indonesian',
    'it' => 'Italian',
    'ja' => 'Japanese',
    'kn' => 'Kannada',
    'kk' => 'Kazakh',
    'kok' => 'Konkani',
    'ko' => 'Korean',
    'kz' => 'Kyrgyz',
    'lv' => 'Latvian',
    'lt' => 'Lithuanian',
    'ms' => 'Malay',
    'ml' => 'Malayalam',
    'mt' => 'Maltese',
    'mr' => 'Marathi',
    'mn' => 'Mongolian',
    'ne' => 'Nepali',
    'no' => 'Norwegian',
    'or' => 'Oriya',
    'pl' => 'Polish',
    'pt' => 'Portuguese',
    'pa' => 'Punjabi',
    'rm' => 'Rhaeto-Romanic',
    'ro' => 'Romanian',
    'ru' => 'Russian',
    'sa' => 'Sanskrit',
    'sr' => 'Serbian',
    'sk' => 'Slovak',
    'ls' => 'Slovenian',
    'sb' => 'Sorbian',
    'es' => 'Spanish',
    'sx' => 'Sutu',
    'sw' => 'Swahili',
    'sv' => 'Swedish',
    'syr' => 'Syriac',
    'ta' => 'Tamil',
    'tt' => 'Tatar',
    'te' => 'Telugu',
    'th' => 'Thai',
    'ts' => 'Tsonga',
    'tn' => 'Tswana',
    'tr' => 'Turkish',
    'uk' => 'Ukrainian',
    'ur' => 'Urdu',
    'uz' => 'Uzbek',
    'vi' => 'Vietnamese',
    'xh' => 'Xhosa',
    'yi' => 'Yiddish',
    'zu' => 'Zulu');
	#    	
	if($lang) return $langtable[$lang];

    #    
	$userlang = strtolower($_SERVER["HTTP_ACCEPT_LANGUAGE"]);
    $userlang = explode(",", $userlang);

    $langs=array();
    foreach($userlang as $key=>$val) {
        $i=substr($val, 0, 2);
        $langs[$i]=$langtable[$i];
    }

    $nclang=Language_Show();

    foreach($langs as $key=>$val) {
        if (in_array($val, $nclang, true)) {
            return($ADMIN_LANGUAGE);
        }
    }

return false;
}


function  Unauthorize ()
{
	$sname = session_name();
    global $HTTP_HOST, $EDIT_DOMAIN, $AUTHORIZATION_TYPE;
    global $PHP_AUTH_USER, $PHP_AUTH_PW, $_SERVER, $PHP_AUTH_LANG, $PHP_AUTH_SID;
    global $PHPSESSID;
    global $db, $$sname;

    if ($AUTHORIZATION_TYPE=='cookie')
    {
        $EditDomainHost = substr($EDIT_DOMAIN,0,strlen($EDIT_DOMAIN)-strlen(strchr($EDIT_DOMAIN,"/")));
		$db->query("DELETE FROM Session WHERE Session_ID = '".$PHP_AUTH_SID."' OR SessionTime < ".time());
        setcookie ("PHP_AUTH_SID", NULL, NULL, "/");
        setcookie ("PHP_AUTH_LANG", NULL, NULL, "/");
    }
    elseif ($AUTHORIZATION_TYPE=='http')
    {
        unset($_SERVER['PHP_AUTH_USER']);
        unset($_SERVER['PHP_AUTH_PW']);
        unset($_SERVER['HTTP_AUTHORIZATION']);
    }
    elseif ($AUTHORIZATION_TYPE=='session')
    {
        if ($$sname != "")
        {
        	$db->query("DELETE FROM Session WHERE Session_ID = '".$$sname."' OR SessionTime < ".time());
            $$sname = $_POST['$sname'];
            $$sname = $_GET['$sname'];
        }
        session_start();
        unset($_SESSION['User']);
        session_destroy();
    }
}

function LoginFormHeader ()
{
    global $VERSION_ID, $SYSTEM_NAME;
    ?>
<html>
    <head>
        <style>
			body {
				margin:0px;
				background-color:white;
			}
			td,th,.plain {
				font-family:verdana;
				font-size:70%;
			}
		</style>
        <title>NetCat <?echo $VERSION_ID?> <?echo $SYSTEM_NAME?></title>
    </head>
    <body marginheight=0 marginwidth=0>
        <table border=0 cellpadding=4 cellspacing=0 width=100% height=100%>
            <tr>
                <td align=center bgcolor=#3c7ea4 height=30><font color=white><b><?=CONTROL_AUTH_HTML_CMS?> <a href="http://www.netcat.ru" style="color:#FFFFFF;">NetCat</a> <?echo $VERSION_ID?> <?echo $SYSTEM_NAME?></td>
            </tr>
            <tr>
                <td height=100% align=center>
    <?
}

function LoginFormFooter ()
{
    ?>
                </td>
            </tr>
            <tr>
                <td align=center bgcolor=#3c7ea4 height=30><font color=white>&copy; 1999-<?echo date("Y")?> <a href=http://www.aist.ru><font color=white><?=ENDHTML_AIST?></a></td>
            </tr>
        </table>
    </body>
</html>
    <?
}


/**
  *    
  */
function LoginForm () {
  global $REQUEST_URI, $AUTH_USER, $ADMIN_LANGUAGE;
  global $posting, $USER_LANG, $ADMIN_AUTHTYPE, $AUTHORIZATION_TYPE, $_COOKIE;

  echo "<form action='".$REQUEST_URI."' method='post'>\n";
	echo "<input type='hidden' name='AuthPhase' value='1'>\n";
	echo "<table border='0' cellpadding='4' cellspacing='0'>\n";
  echo "\t<tr>\n";
	echo "\t\t<td>".CONTROL_AUTH_HTML_LOGIN.":</td>\n";
	echo "\t\t<td><input type='text' name='AUTH_USER' size='32' maxlength='255' value='".htmlspecialchars(stripcslashes($AUTH_USER))."'></td>\n";
	echo "\t</tr>\n";
	echo "\t<tr>\n";
	echo "\t\t<td>".CONTROL_AUTH_HTML_PASSWORD.":</td>\n";
	echo "\t\t<td><input type='password' name='AUTH_PW' size='32' maxlength='32'></td>\n";
	echo "\t</tr>\n";
	echo "\t<tr>\n";
	echo "\t\t<td>".CONTROL_AUTH_HTML_LANG.":</td>\n";
	echo "\t\t<td>\n";
	echo "\t\t\t<select name='NEW_AUTH_LANG'>\n";

  $lang = Language_Show();

  if ($_COOKIE['PHP_AUTH_LANG']) {
    $sellang = $_COOKIE['PHP_AUTH_LANG'];
  } else {
    $sellang = $ADMIN_LANGUAGE;
  }

  foreach($lang as $key=>$val) {
    if ($val == $sellang) {
      echo "\t\t\t\t<option name='".$key."' selected='selected'>".$val."</option>\n";
    } else {
      echo "\t\t\t\t<option name='".$key."'>".$val."</option>\n";
    }
  }
  
  echo "\t\t\t</select>\n";
  echo "\t\t</td>";
	echo "\t</tr>";

  if ($ADMIN_AUTHTYPE == 'manual' && $AUTHORIZATION_TYPE == 'cookie') {
    echo "\t<tr>\n";
		echo "\t\t<td></td>\n";
		echo "\t\t<td><label><input type='checkbox' name='loginsave' />&nbsp;".CONTROL_AUTH_HTML_SAVELOGIN."</label></td>\n";
    echo "\t</tr>\n";
  }

  echo "\t<tr>\n";
	echo "\t\t<td></td>\n";
	echo "\t\t<td>\n";
	echo "\t\t\t<input type='submit' name='submit' value='".CONTROL_AUTH_HTML_AUTH."'>\n";
     
  if ($posting && $REQUEST_URI != $REQUESTED_FROM) {
    echo "\t\t\t<br><a href='".$REQUESTED_FROM."'>".CONTROL_AUTH_HTML_BACK."</a>";
  }

  echo "\t\t</td>\n";
	echo "\t</tr>\n";
    
  echo "</table>\n";
	echo "</form>\n";
}

function Refuse ()
{
    global $db, $ADMIN_FOLDER;
    global $AUTH_TYPE, $AUTH_LANG, $PHP_AUTH_LANG, $_SESSION, $ADMIN_LANGUAGE;
    global $NOT_AUTHORIZE_MESSAGE;
    global $admin_mode;

    if (preg_match("/^\w+$/",$AUTH_LANG))
    {
        require_once($ADMIN_FOLDER."lang/".$AUTH_LANG.".php");
    }
    elseif (preg_match("/^\w+$/", $PHP_AUTH_LANG))
    {
        require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
    }
    elseif (preg_match("/^\w+$/", $_SESSION['User']['PHP_AUTH_LANG']))
    {
        require_once($ADMIN_FOLDER."lang/".$_SESSION['User']['PHP_AUTH_LANG'].".php");
    }
    else
    {
        if (!$PHP_AUTH_LANG)
        {
            $PHP_AUTH_LANG=NetCat_language_detect();
        }

        if ($PHP_AUTH_LANG)
        {
            require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
        }
        else
        {
            require_once($ADMIN_FOLDER."lang/".$ADMIN_LANGUAGE.".php");
        }
    }

    if ($_POST["NC_HTTP_REQUEST"] || NC_ADMIN_ASK_PASSWORD===false) // AJAX call
    {
       // issue strange header (actually not RFC2616-compliant) and die
       header($_SERVER['SERVER_PROTOCOL']." 401 Authorization Required");
       exit;
    }

    switch ($AUTH_TYPE)
    {
        case 'cookie':
            if (!$admin_mode)
            {
                UserLoginForm ();
            }
            else
            {
                LoginFormHeader();
                LoginForm ();
                LoginFormFooter();
            }
            break;

        case 'session':
            if (!$admin_mode)
            {
                UserLoginForm ();
            }
            else
            {
                LoginFormHeader();
                LoginForm ();
                LoginFormFooter();
            }
            break;

        default :
            #    'http'
            Header ("WWW-authenticate:  basic  realm=Enter your login and password");
            Header ($_SERVER['SERVER_PROTOCOL'].' 401  Unauthorized');
            LoginFormHeader();
            print CONTROL_AUTH_MSG_MUSTAUTH;
            LoginFormFooter();
            end;
    }
    exit;
}

function Authorize ($IsInAdmin=0)
{
	$sname = session_name();
	global $PHP_AUTH_USER, $PHP_AUTH_PW, $PHP_AUTH_LANG,$PHP_AUTH_SID;
	global $AUTH_USER_ID, $AUTH_USER_GROUP;
	global $AUTH_USER, $AUTH_PW, $AUTH_LANG;
	global $AUTHORIZATION_TYPE;
	global $EDIT_DOMAIN, $AUTH_TYPE, $HTTP_HOST;
	global $db, $SUB_FOLDER;
	global $perm, $AuthPhase, $admin_mode;
	global $AUTHORIZE_BY, $MODULE_VARS;
	global $$sname, $ADMIN_AUTHTIME, $ADMIN_AUTHTYPE;
	
	$AUTH_TYPE       = $AUTHORIZATION_TYPE;    
	$AUTH_USER_ID    = 0;
	$AUTH_USER_GROUP = 0;
	
	
	// SESSION  
	if ($AUTH_TYPE == 'session') {
		if ($$sname) {
			$_GET[session_name()]  = $$sname;
            $_POST[session_name()] = $$sname;
		}
		else {
			$session_id = md5(uniqid(rand(), 1));
            session_id($session_id);
		}
		
		session_start();
		if ($_SESSION['User']['IsLogin'] == "1") {
			if ($_SESSION['User']['IP'] != getenv("REMOTE_ADDR")) header ("Location: ".$SUB_FOLDER."/");
			if ((time()-$_SESSION['User']['datetime']) > ini_get('session.gc_maxlifetime')) unset($_SESSION['User']);
		}
		$_SESSION['User']['datetime'] = time();
		$PHP_AUTH_USER = $_SESSION['User']['PHP_AUTH_USER'];
		$PHP_AUTH_PW   = $_SESSION['User']['PHP_AUTH_PW'];
		$PHP_AUTH_LANG = $_SESSION['User']['PHP_AUTH_LANG'];
	}

	
	//  () || HTTP 
	if ($AuthPhase || $AUTH_TYPE == 'http') {
		if ($AUTH_TYPE != 'http') {
			$PHP_AUTH_USER = $AUTH_USER;
			$PHP_AUTH_PW   = $AUTH_PW;
			$PHP_AUTH_LANG = $AUTH_LANG;
		}
		$result = $db->get_row("SELECT User_ID,Password,PermissionGroup_ID,Language,".$AUTHORIZE_BY.",InsideAdminAccess, Catalogue_ID
			FROM User 
			WHERE ".$AUTHORIZE_BY."='".$PHP_AUTH_USER."' AND Password=PASSWORD('".$PHP_AUTH_PW."') AND Checked=1", ARRAY_A);

	
	
	} // SESSION 
	elseif ($AUTH_TYPE == 'session') {
		$result = $db->get_row("SELECT u.User_ID,u.Password,u.PermissionGroup_ID,u.Language,u.".$AUTHORIZE_BY.",s.LoginSave,u.InsideAdminAccess,u.Catalogue_ID 
			FROM User AS u 
			RIGHT JOIN Session AS s 
			ON u.User_ID = s.User_ID 
			WHERE u.Checked = 1 AND u.User_ID != 0 AND s.Session_ID = '".$$sname."' AND s.SessionTime > ".time(), ARRAY_A);
	
	
	} // COOKIE 
	elseif ($AUTH_TYPE == 'cookie') {
		$result = $db->get_row("SELECT u.User_ID,u.Password,u.PermissionGroup_ID,u.Language,u.".$AUTHORIZE_BY.",s.LoginSave,u.InsideAdminAccess,u.Catalogue_ID 
			FROM User AS u 
			RIGHT JOIN Session AS s 
			ON u.User_ID = s.User_ID 
			WHERE u.Checked = 1 AND u.User_ID != 0 AND s.Session_ID = '".$PHP_AUTH_SID."' AND s.SessionTime > ".time(), ARRAY_A);
	}
	
	
	if (!$result) {
		if ($admin_mode || $AUTH_TYPE == "http") {
			Refuse();
		}
		else {
			return false;
		}
	}
	$UserID            = $result['User_ID'];
	$Password          = $result['Password'];
	$UserGroup         = $result['PermissionGroup_ID'];
	$Language          = $result['Language'];
	$PHP_AUTH_USER     = $result['Login'];
	$LoginSave         = ($result['LoginSave'] || $ADMIN_AUTHTYPE == 'always' ? 1 : 0);
	$InsideAdminAccess = $result['InsideAdminAccess'];
	$Catalogue_ID      = $result['Catalogue_ID'];

	
	$PHP_AUTH_PW = $Password;
	if ($Language) $AUTH_LANG = $PHP_AUTH_LANG = $Language;
	
	
	if ($AUTH_TYPE != 'http') {
		$SessionStart = time();
		$SessionTime = ($ADMIN_AUTHTIME ? $SessionStart+$ADMIN_AUTHTIME : $SessionStart+24*3600);
		$UserIP = sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));
	}
	
	
	// SESSION /
	if ($AUTH_TYPE == 'session') {		
		if ($AuthPhase) {
			$OldSid = ($$sname ? $$sname : session_id());
			$db->query("DELETE FROM Session WHERE SessionTime < ".$SessionStart.($OldSid ? " OR Session_ID = '".$OldSid."'" : ""));
			
			$db->query("INSERT INTO Session (Session_ID, User_ID, SessionStart, SessionTime, UserIP, LoginSave, Catalogue_ID) VALUES ('".$$sname."', ".$UserID.", ".$SessionStart.", ".$SessionTime.", ".$UserIP.",".$LoginSave.",".$Catalogue_ID.")");
		}
		else {
			$db->query("UPDATE Session SET SessionTime = ".$SessionTime." WHERE Session_ID = '".$$sname."'");
		}
		
		$_SESSION['User']['ID']            = $UserID;
		$_SESSION['User']['PHP_AUTH_USER'] = $PHP_AUTH_USER;
		$_SESSION['User']['PHP_AUTH_PW']   = $Password;
		$_SESSION['User']['PHP_AUTH_LANG'] = $PHP_AUTH_LANG;
		$_SESSION['User']['datetime']      = $SessionStart;
		$_SESSION['User']['IsLogin']       = "1";
		$_SESSION['User']['IP']            = $_SERVER['REMOTE_ADDR'];
		
		
		
	
	}
	
	// COOKIE /
	elseif ($AUTH_TYPE == 'cookie') {
		if ($AuthPhase) {
			$OldSid = ($PHP_AUTH_SID ? $PHP_AUTH_SID : $$sname);
			$db->query("DELETE FROM Session WHERE SessionTime < ".$SessionStart.($OldSid ? " OR Session_ID = '".$OldSid."'" : ""));
			$LoginSave = ($_POST['loginsave'] || $ADMIN_AUTHTYPE == "always" ? 1 : 0);
			
			$PHP_AUTH_SID = ($$sname ? $$sname : md5(uniqid(rand(), 1)));
			$result = $db->query("INSERT INTO Session (Session_ID, User_ID, SessionStart, SessionTime, UserIP, LoginSave, Catalogue_ID) VALUES ('".$PHP_AUTH_SID."',".$UserID.",".$SessionStart.",".$SessionTime.",".$UserIP.",".$LoginSave.",".$Catalogue_ID.")");
			
			$_COOKIE['PHP_AUTH_SID']  = $PHP_AUTH_SID;
			$_COOKIE['PHP_AUTH_LANG'] = $PHP_AUTH_LANG;			
		}
		// 
		else {
			$db->query("UPDATE Session SET SessionTime = ".$SessionTime.", UserIP = ".$UserIP." WHERE Session_ID = '".$PHP_AUTH_SID."'");
		}
		
		if (!$LoginSave) $SessionTime = 0;
		$domain = ($MODULE_VARS['auth']['COOKIES_WITH_SUBDOMAIN'] ? $HTTP_HOST : NULL);
		setcookie('PHP_AUTH_SID',  $PHP_AUTH_SID,  $SessionTime, "/", $domain);
		setcookie('PHP_AUTH_LANG', $PHP_AUTH_LANG, $SessionTime, "/", $domain);
	}
	
	// HTTP
	elseif ($AUTH_TYPE == 'http') {
		end;
	}
	
	elseif ($admin_mode || $AUTHORIZATION_TYPE == "http") {
		Refuse();
	}
	
	else {
		return false;
	}
	
	
	
	$AUTH_USER_ID    = $UserID;
	$AUTH_USER_GROUP = $UserGroup;
	
	$perm = new Permission ($UserID);
	if ($InsideAdminAccess == '0') $perm->InsideAdminAccessDeny = 1;
	
	return ($UserID);
}

function CheckUserRights ($SubClassID, $action, $posting)
{
    global $db;
    global $perm;
    #  action
    #   1 - read
    #   2 - add
    #   4 - subscribe
    #   8 - change
    #  16 - moderate

    if (!$perm) Authorize();
    if ( $perm->isSupervisor() )
    {
        return 1;
    }
    if ( $perm->isManager() )
    {
        return 1;
    }

    switch ($action)
    {
        case "read":
            $mask = 1;
            break;
        case "add":
            $mask = 2;
            break;
        case "change":
            $mask = 4;
            break;
        case "subscribe":
            $mask = 8;
            break;
        case "moderate":
            $mask = 16;
            break;
        default:
            $mask = 1;
            break;
    }

    if ( $perm->isGuest() )
    {
        if ($posting == 0)
        {
            return 1;
        }
        elseif ( $mask == 1 )
        {
            return 1;
        }
        else
        {
            return 0;
        }
    }
    $SubdivisionID = GetSubdivisionBySubClass ($SubClassID);
    $CatalogueID = GetCatalogueBySubdivision ($SubdivisionID);
    if ( $perm->isCatalogue($CatalogueID, $mask) )
    {
        return $perm->isCatalogue ($CatalogueID, $mask);
    }

    while ($SubdivisionID)
    {
        $val = $perm->isSubdivision ($SubdivisionID, $mask);
        if ($val == 1)
        {
            return 1;
        }
        $SubdivisionID = GetParentSubID ($SubdivisionID);
    }

    if ( $perm->isSubClass($SubClassID, $mask) )
    {
        return $perm->isSubClass ($SubClassID, $mask);
    }
    return 0;
}
?>