<?php
/* $header$ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($INCLUDE_FOLDER."index.php");

global $db, $current_user, $perm, $MODULE_VARS;
#  
$sub = (int)$sub;
$cc = (int)$cc;

# $sub     ,    
#  
$is_blog = $db->get_var("SELECT `ID` FROM `Blog_Subdivision` WHERE `Subdivision_ID` = '".$sub."'");
#  
if (!$is_blog) $is_blog_main = $db->get_var("SELECT `ID` FROM `Blog_Parent` WHERE `Subdivision_ID` = '".$sub."'");

$SQLres = $db->get_row("SELECT `Catalogue_ID`, `Parent_Sub_ID`, `Hidden_URL`
	FROM `Subdivision`
	WHERE `Subdivision_ID` = '".$sub."'", ARRAY_A);

$parentSub = $is_blog ? $SQLres['Parent_Sub_ID'] : ($is_blog_main ? $sub : 0);
$catalogue = $SQLres['Catalogue_ID'];
$Hidden_URL = $SQLres['Hidden_URL'];

#    
if($inside_admin) $goBackLink = $admin_url_prefix."?catalogue=".$catalogue."&amp;sub=".$sub."&amp;cc=".$cc.($curPos ? "&amp;curPos=".$curPos."" : "");

# Header
eval("echo \"$template_header\";");

#  ,    
if( empty($current_user) ) {
	if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
	echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_NOPERMISSIONS, $goBackLink, "error") );
	#  Footer   
	eval("echo \"$template_footer\";");
	exit;
}	

switch($nc_blog_operation) {

	#  
	case "create_blog":
		
		#      
		$blogType = nc_blog_get_type($parentSub);
		
		#   Subdivision_Name
		if( isset($blogTitle) ) {
			$blogTitle = $db->escape($blogTitle);
		}
		else {
			$blogTitle = "";
		}
			
		#    
		if($blogType=="collective" || $blogType=="corporative") {
			$blogName = strtolower( $db->escape($blogName) ); 
		}
		elseif($blogType=="personal" && !$ruName) {
			$blogName = strtolower( $db->escape($current_user['Login']) ); 
		}
		// elseif(!$ruName) {
			// if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
			// echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_ERROR, $goBackLink, "error") );
		// }

		#    
		$rusName = preg_match("/^.*?[-]+.*?$/i", $blogName);
		if($rusName) {
			$blogName = nc_transliterate($blogName);
			$blogName = strtr($blogName, array("'"=>"", " "=>"-") );
		}
		# 
		$validName = preg_match("/^[a-z0-9-]+$/", $blogName);
		if($validName && $blogName) {
			#    
			$userExist = nc_blog_check_name($sub, $blogName);
			#      
			if($blogType=="personal") {
				#       
				$subdivisions = $db->get_col("SELECT Subdivision_ID FROM Subdivision WHERE Parent_Sub_ID='".$parentSub."'");
				if($subdivisions)
				$notCreate = $db->get_var("SELECT Catalogue_ID FROM Permission
									       WHERE User_ID='".$current_user['User_ID']."'
									       AND AdminType=3
									       AND PermissionSet='".$MODULE_VARS['blog']['BLOG_ADMIN_PERMISSION']."'
									       AND Catalogue_ID IN (".join(",", $subdivisions).")");
			}
			
			# ...
			if( ($userExist && $notCreate) || ($userExist && $blogType=="collective") ) {
				echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_BLOGNAME_EXIST, "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>", "error") );
			}		  
			elseif($userExist && !$notCreate && $blogType=="personal") {
				echo NETCAT_MODULE_BLOG_INFO_BLOGNAME_EXIST."<br>".NETCAT_MODULE_BLOG_INFO_BLOGNAME_TRY_OTHER."<br><br>
					  <form enctype='multipart/form-data' method='post' action='".$SUB_FOLDER.$HTTP_ROOT_PATH."modules/blog/add.php'>
				      <input name='sub' value='".$sub."' type='hidden'>
				      <input name='cc' value='".$cc."' type='hidden'>
				      <input name='nc_blog_operation' value='create_blog' type='hidden'>
					  <input name='ruName' value='1' type='hidden'>
				      <input type='text' name='blogName' value='".$blogName."'>
				      <input value='".NETCAT_MODULE_BLOG_CREATE."' type='submit'>
				      </form>";
			}
			else {
				#        
				$error = nc_blog_create_blog($sub, $catalogue, $Hidden_URL,  $subName, $blogName, $blogType, $blogTitle);
				
				if(!$error) {
					#   
					if($admin_mode)
						$goBackLink = $admin_url_prefix."?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&curPos=".$curPos."";
					else
						$goBackLink = $Hidden_URL.$blogName."/settings.html";
						
					echo nc_blog_redirect($goBackLink, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_BLOG_CREATED, NETCAT_MODULE_BLOG_INFO_GOTO_SETTINGS, "ok") );
				}
				else {
					echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_ERROR, "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>", "error") );
				}
			}
		}
		else {
			echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_BLOG_NAME_NOT_CORRECT, "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>", "info") );
		}
	
	# create_blog
	break;

	#   
	case "join_blog":
	case "unjoin_blog":

		#  ,     
		if($nc_blog_operation=="unjoin_blog") {
			$access = (bool)$perm->isSubClass($cc, 4);
			if(!$access) {
				if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
				echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_NOPERMISSIONS, $goBackLink, "error") );
			}
		}
		
		$blogType =  nc_blog_get_type($sub, 1);
		$userPerm = nc_blog_user_permission($sub, $cc);
		$userscc = $db->get_var("SELECT Sub_Class_ID FROM Sub_Class WHERE Subdivision_ID=".$sub." AND EnglishName='users'");
		$userID = $current_user['User_ID'];
		
		if($nc_blog_operation=="join_blog") {
			if(!$userPerm && $blogType=="collective") {
				$join_result = nc_blog_addrop_user($sub, $userscc, $userID, "add", 2);
			}
		}
		elseif($nc_blog_operation=="unjoin_blog") {
			if($userPerm=="u") {
				$join_result = nc_blog_addrop_user($sub, $userscc, $userID, "drop", 2);
			}
		}

		if($join_result) {
			if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
			echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_COMPLETE, $goBackLink, "info") );
		}
		else {
			echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_ERROR, "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>", "error") );
		}
	
	# join_blog || unjoin_blog
	break;

	#    (   )
	case "add_user":
	case "drop_user":

		#        
		$blogType = nc_blog_get_type($sub, 1);

		#    
		if($blogType=="personal") {
			#   
			if($ignore_user) {
				$userID = (int)$ignore_user;
			}
			else {
				# ID   ,       
				$userID = $db->get_var("SELECT User_ID FROM Permission
										WHERE AdminType=3
										AND PermissionSet='".$MODULE_VARS['blog']['BLOG_ADMIN_PERMISSION']."'
										AND Catalogue_ID='".$sub."'");
			}
			
			#  
			#     ,       
			$subdivisions = $db->get_col("SELECT Subdivision_ID FROM Subdivision WHERE Parent_Sub_ID='".$parentSub."'");
			if($subdivisions)
			$mysub = $db->get_var("SELECT Catalogue_ID FROM Permission
								   WHERE User_ID='".$current_user['User_ID']."'
								   AND AdminType=3
								   AND PermissionSet='".$MODULE_VARS['blog']['BLOG_ADMIN_PERMISSION']."'
								   AND Catalogue_ID IN (".join(",", $subdivisions).")");
			if($mysub)
			$myusercc = $db->get_var("SELECT Sub_Class_ID FROM Sub_Class WHERE Class_ID=".$MODULE_VARS['blog']['BLOG_MESSAGES_USERS_CLASS_ID']." AND Subdivision_ID=".$mysub." AND EnglishName='users'");
			if($ignore_user) $permission = 4; else $permission = 1; # user status
		}
		elseif($blogType=="collective") {
			# U, M, A
			$userPerm = nc_blog_user_permission($sub, $cc);
			if($userPerm=="a") {
				#  
				$userID = $ignore_user;
				#  
				$mysub = $sub;
				$myusercc = $db->get_var("SELECT Sub_Class_ID FROM Sub_Class WHERE Class_ID=".$MODULE_VARS['blog']['BLOG_MESSAGES_USERS_CLASS_ID']." AND Subdivision_ID=".$sub." AND EnglishName='users'");
				$permission = 4; # ignore status
			}
		}
		#   
		if($mysub && $myusercc && $userID) {
			if($nc_blog_operation=="add_user")
				$result = nc_blog_addrop_user($mysub, $myusercc, $userID, "add", $permission);
			else
				$result = nc_blog_addrop_user($mysub, $myusercc, $userID, "drop", $permission);
		}
		#  footer
		if($result) {
			if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
			echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice($blogType=="collective" ? NETCAT_MODULE_BLOG_INFO_USERS_LIST_SAVED : NETCAT_MODULE_BLOG_INFO_FRIEND_LIST_SAVED, $goBackLink, "info") );
		}
		else {
			echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_ERROR, "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>", "error") );
		}
	
	# add_user || drop_user
	break;

	#        
	case "save_users":
		
		#  ,     
		$access = ( (bool)$perm->isSubdivisionAdmin($sub) || (bool)$perm->isDirector() || (bool)$perm->isSupervisor() );
		if(!$access) {
			if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
			echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_NOPERMISSIONS, $goBackLink, "error") );
		}
		
		$result = nc_blog_users_settings($sub, $f_Permission, $f_Delete);
			
		if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
		echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(($result ? NETCAT_MODULE_BLOG_INFO_SETTINGS_SAVED : NETCAT_MODULE_BLOG_INFO_NOSETTINGS_TO_SAVE), $goBackLink, "ok") );
	
	# save_users
	break;

	case "visual_settings":

		#  ,     
		$access = ( (bool)$perm->isSubdivisionAdmin($sub) || (bool)$perm->isDirector() || (bool)$perm->isSupervisor() );
		if(!$access) {
			if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
			echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_NOPERMISSIONS, $goBackLink, "error") );
		}

		nc_blog_visual_settings($sub, "", "", "", $CustomSettings);
			
		if(!$inside_admin) $goBackLink = "<a href='%URL'>".NETCAT_MODERATION_BACKTOSECTION."</a>";
		echo nc_blog_redirect($Hidden_URL, nc_blog_make_notice(NETCAT_MODULE_BLOG_INFO_SETTINGS_SAVED, $goBackLink, "ok") );
	
	# visual_settings	
	break;
	
}

# Footer
eval("echo \"$template_footer\";");
?>