<?php

/**
  *      
  * @param int   
  * @return string html- 
  */
function nc_set_calendar($id = 0) {
global $db, $SUB_FOLDER, $HTTP_ROOT_PATH;

	$id = (int)$id;
	
	$css = $db->get_var("SELECT `CalendarCSS`
		FROM `Calendar_Settings`
		WHERE ".($id ? "ID = '".$id."'" : "DefaultTheme = '1'")."");

	$result = "<style type='text/css'>\r\n".$css."</style>\r\n";
	$result.= "<script type='text/javascript'>var SUB_FOLDER = '".$SUB_FOLDER."', NETCAT_PATH = '".$HTTP_ROOT_PATH."';</script>\r\n";
	$result.= "<script type='text/javascript' src='/netcat/admin/js/lib.js'></script>\r\n";
	$result.= "<script type='text/javascript' src='".$SUB_FOLDER.$HTTP_ROOT_PATH."modules/calendar/calendar.js'></script>";
	
return $result;
}


/**
  *     ,    , ..   
  * @param int  
  * @param int   ,   
  * @param int  
  * @param int   ,   
  * @param int    
  * @param int   ,     
  * @return bool
  */
function nc_calendar_read_permission($catalogue, $Catalogue_Read_Access, $sub, $Subdivision_Read_Access, $cc, $Sub_Class_Read_Access) {
global $db, $AUTH_USER_ID, $perm;

	#   , ,   ,  "",     ,  
	if($Catalogue_Read_Access==1 && $Subdivision_Read_Access==1 && $Sub_Class_Read_Access==1) return true;
	
	#   , ,   ,  ""   ,     ,  
	if($AUTH_USER_ID) {
		#        ,   
		#     ,         -     
		#       ,        -     
		if($Catalogue_Read_Access==2 || $Subdivision_Read_Access==2 || $Sub_Class_Read_Access==2) return true;
	}
	
	#        $perm
	if( !$AUTH_USER_ID || !class_exists("Permission") || !is_object($perm) ) return false;

	#  
	$AdmRights = ( $perm->isDirector() ||					# 
				   $perm->isSupervisor() ||					# 
				   $perm->isManager() ||					# 
				   $perm->isCatalogueAdmin($catalogue) ||	#   $catalogue
				   $perm->isSubdivisionAdmin($sub) ||		#   $sub
				   $perm->isSubClassAdmin($cc)				#   $cc
	);
	#       ,  
	if($AdmRights) return true;
	
	#   
	$i = 0;
	$parent_sub = $sub;
	$parent_sub_array = array($sub);
	while($parent_sub) {
		$parent_sub = $db->get_var("SELECT `Parent_Sub_ID`
			FROM `Subdivision`
			WHERE `Subdivision_ID` = '".$parent_sub."'");
		if(!$parent_sub) break;
		$parent_sub_array[] = $parent_sub;
	$i++;
	}

	#   
	$Permissions = $perm->ARRAY;
	# AdminType==4:  
	# AdminType==3:  
	# AdminType==9:    
	# $Permission[0] - Catalogue_ID -   (, ,   )
	# $Permission[1] - Permission_ID -  	
	# $Permission[2] - PermissionSet -    (1 - ,3 - ,7 - ,15 - ,31 - ,63 - )
	if ( !empty($Permissions) ) {
		foreach($Permissions AS $AdminType => $Permission) {
			foreach($Permission AS $value) {
				if($AdminType==4 && $value[2]>=1 && $value[0]==$catalogue) return true;
				if($AdminType==3 && $value[2]>=1 && in_array($value[0], $parent_sub_array) ) return true;
				if($AdminType==9 && $value[2]>=1 && $value[0]==$cc) return true;
			}
		}
	}
	
return false;
}


/**
  *  
  * @param int   
  * @param int    
  * @param string   
  * @param bool     
  * @return string html- 
  */
function nc_show_calendar($theme = 0, $cc = 0, $setDate = 0, $DateField = "Date", $filled = false) {
global $db, $DOCUMENT_ROOT, $SUB_FOLDER, $HTTP_ROOT_PATH;

	#   
	if($DateField) $DateField = $db->escape($DateField);
	#     ,  ,   
	$date = $setDate ? $setDate : $GLOBALS['date'];
	# 
	$antiJumper = true;
	$theme = (int)$theme;
	$curr_year = date("Y");
	$imagesPath = $SUB_FOLDER.$HTTP_ROOT_PATH."modules/calendar/images/";

	#    $cc,   
	if(!$cc) {
		global $catalogue, $sub, $cc, $classID, $current_catalogue, $current_sub, $current_cc;
		$Catalogue_Read_Access = $current_catalogue['Read_Access_ID'];
		$Subdivision_Read_Access = $current_sub['Read_Access_ID'];
		$Sub_Class_Read_Access = $current_cc['Read_Access_ID'];
		$Hidden_URL = $current_sub['Hidden_URL'];
	}
	else {
	#   $cc,    
		$cc_data = $db->get_row("SELECT sub.`Catalogue_ID` AS Catalogue_ID,
			sc.`Subdivision_ID` AS Subdivision_ID,
			sc.`Class_ID` AS Class_ID,
			sub.`Hidden_URL` AS Hidden_URL,
			cat.`Read_Access_ID` AS Catalogue_Read_Access,
			sub.`Read_Access_ID` AS Subdivision_Read_Access,
			sc.`Read_Access_ID` AS Sub_Class_Read_Access
			FROM `Sub_Class` AS sc
			LEFT JOIN `Subdivision` AS sub
			ON sc.`Subdivision_ID` = sub.`Subdivision_ID`
			LEFT JOIN `Catalogue` AS cat
			ON sub.`Catalogue_ID` = cat.`Catalogue_ID`
			WHERE sc.`Sub_Class_ID` = '".$cc."'", ARRAY_A);
		#   ,  
		if( !empty($cc_data) ) {
			$catalogue = $cc_data['Catalogue_ID'];
			$sub = $cc_data['Subdivision_ID'];
			$classID = $cc_data['Class_ID'];
			$Catalogue_Read_Access = $cc_data['Catalogue_Read_Access'];
			$Subdivision_Read_Access = $cc_data['Subdivision_Read_Access'];
			$Sub_Class_Read_Access = $cc_data['Sub_Class_Read_Access'];
			$Hidden_URL = $cc_data['Hidden_URL'];
		}
		else {
			trigger_error("<b>nc_show_calendar()</b>: Incorrect \$cc (".$cc.")", E_USER_WARNING);
			return false;
		}
	}
	
	#          
	$read_access = true;###nc_calendar_read_permission($catalogue, $Catalogue_Read_Access, $sub, $Subdivision_Read_Access, $cc, $Sub_Class_Read_Access);
	
	#   
	if($date && preg_match("/^([0-9]{1,4}-?){1,3}$/", $date) ) {
		list($year, $month, $day) = split("-", $date);
		if(!$month) $month = 1;
		if(!$day) $day = 1;
	} 
	else {
		list($year, $month, $day) = split("-", date("Y-m-d") );
	}

	#  
	$settings = $db->get_row("SELECT * FROM `Calendar_Settings`
		WHERE ".($theme ? "`ID` = '".$theme."'" : "`DefaultTheme` = '1'")."", ARRAY_A);

	if( empty($settings) ) {
		trigger_error("<b>nc_show_calendar()</b>: No calendar theme found (".$theme.")", E_USER_WARNING);
		return false;
	}
	
	#   
	if(!$theme) $theme = $settings['ID'];
	
	###_BEGIN:   
	$calendarBody = $settings['dayTemplatePrefix'];
	
	###_BEGIN:   
	$calendarBody.= $settings['dayTemplateBegin'];
	
	#  ,  
	if($settings['DaysName']) {
		$DaysNameArray = split(",", $settings['DaysName']);
		#     ,      :)
		if( !empty($DaysNameArray) && is_array($DaysNameArray) ) {
			$DaysNameArray = array_map("trim", $DaysNameArray);
			$DaysNameArray = array_pad($DaysNameArray, -8, "");
		}
	}
	
	#      
	for($i = 1; $i<=7; $i++) {
		$DayName = $DaysNameArray[$i];
		if( ($i%7)==6 ) $calendarBody.= str_replace("%NAME_DAY", $DayName, $settings['daySETTemplateHeader']);
		elseif( !($i%7) ) $calendarBody.= str_replace("%NAME_DAY", $DayName, $settings['daySUNTemplateHeader']);
		else $calendarBody.= str_replace("%NAME_DAY", $DayName, $settings['dayTemplateHeader']);
	}
	
	$calendarBody.= $settings['dayTemplateEnd'];
	###_END:   
	
	###_BEGIN:  
	$calendarBody.= $settings['dayTemplateBegin'];
	
	#      
	$weekDayBehind = date("w", mktime(0, 0, 0, $month, 1, $year) );
	# 0 - 
	if($weekDayBehind==0) $weekDayBehind=7;
	
	#     
	for($i=1; $i<$weekDayBehind; $i++) {
		# 
		if(($i%7)==6) $calendarBody.= $settings['nodaySETTemplate'];
		# 
		elseif(!($i%7)) $calendarBody.= $settings['nodaySUNTemplate'];
		#     
		else $calendarBody.= $settings['nodayTemplate'];
	} 
	if($weekDayBehind!=1) $lines = $lines + 1;

	#    $month
	$daysInMonth = date("t", mktime(0, 0, 0, $month, 1, $year));

	#  ,  "0",       $month
	$daysMask = array_fill(0, $daysInMonth, $filled ? 1 : 0);
	
	if (!$filled) {
		#    ""  ,     
		if($read_access) {
			# ,    
			$DateFieldExist = nc_calendar_possibility_check($classID, $DateField);
			#    
			if($DateFieldExist) {
				$res = $db->get_col("SELECT DAYOFMONTH(`".$DateField."`)
					FROM `Message".$classID."`
					WHERE `Sub_Class_ID` = '".$cc."'
					AND MONTH(`".$DateField."`) = '".$month."'
					AND YEAR(`".$DateField."`) = '".$year."'
					AND Checked = '1'
					GROUP BY DAYOFMONTH(`".$DateField."`)");
			}
		}
			
		#  ,      - "0",   - "1"
		if( !empty($res) ) {
			foreach($res AS $value) {
				$daysMask[$value-1] = 1;
		    }
		}
	}

	###_BEGIN:  
	for($i=1; $i<=$daysInMonth; $i++) {
		#    ,   (  )
		if($daysMask[$i-1]==1) {
			$dayLinkBegin = "<a href='".$SUB_FOLDER.$Hidden_URL.$year."/".sprintf("%02d", $month)."/".sprintf("%02d", $i)."/'>";
			$dayLinkEnd = "</a>";
		}
		else {
			$dayLinkBegin = $dayLinkEnd = "";
		}
		
		#    
		if( ($weekDayBehind + $i - 1)%7==1 ) {
			if($lines) $calendarBody.= $settings['dayTemplateEnd'].$settings['dayTemplateBegin'];
			$lines = $lines + 1;
		}
		
		# 
		if( ($weekDayBehind + $i - 1)%7==6 && $i!=$day ) $calendarBody.= str_replace("%DAY", $dayLinkBegin.$i.$dayLinkEnd, $settings['daySETTemplate']); 
		# 
		elseif( ($weekDayBehind + $i - 1)%7==0 && $i!=$day ) $calendarBody.= str_replace("%DAY", $dayLinkBegin.$i.$dayLinkEnd, $settings['daySUNTemplate']);
        #  
		elseif($i==$day) $calendarBody.= str_replace("%DAY", $i, $settings['dayCurTemplate']);
		#     
		else $calendarBody.= str_replace("%DAY", $dayLinkBegin.$i.$dayLinkEnd, $settings['dayTemplate']);

	}
	###_END:  
	
	#      
	$weekDayAfter = date("w", mktime(0, 0, 0, $month, $daysInMonth, $year) );
	# 0 - 
	if($weekDayAfter==0) $weekDayAfter=7;
	
	#  ,    "",   
	$daysEnd = ($antiJumper ? 7*($lines<6 ? 7-$lines : 1) : 7);
	
	#      
	for($i=$weekDayAfter; $i<$daysEnd; $i++) {
		#    
		if(($i+1)%7==1 && $daysEnd>7) $calendarBody.= $settings['dayTemplateEnd'].$settings['dayTemplateBegin'];
		# 
		if((($i+1)%7)==6) $calendarBody.= $settings['nodaySETTemplate'];
		# 
		else if(!(($i+1)%7)) $calendarBody.= $settings['nodaySUNTemplate'];
		#     
		else $calendarBody.= $settings['nodayTemplate'];
	}
	
	$calendarBody.= $settings['dayTemplateEnd'];
	###_END:  
	
	$calendarBody.= $settings['dayTemplateSuffix'];
	###_END:   

	#       
	eval("\$MonthArray = ".NETCAT_MODULE_CALENDAR_MONTH_NAME_ARRAY.";");
	#      ,  
	if( is_array($MonthArray) ) $MonthArray = array_pad($MonthArray, -13, "");

	#   ""
	$month_select = "<select onchange='nc_calendar_generate(".$day.", this.value, ".$year."); return false;'>";
	for($monthCount = 1; $monthCount<=12; $monthCount++) {
		$month_select.= "<option value='".$monthCount."'".($month==$monthCount ? " selected" : "").">".$MonthArray[$monthCount]."</option>";
	}
    $month_select.= "</select>";
	
	#   ""
	$year_select = "<select onchange='nc_calendar_generate(".$day.", ".$month.", this.value); return false;'>";
    $limit = $curr_year + 10; 
	for($yearCount=($curr_year-10); $yearCount<=$limit; $yearCount++) {
		$year_select.= "<option value='".$yearCount."'".($year==$yearCount ? " selected" : "").">".$yearCount."</option>";
	}
    $year_select.= "</select>";
	
	if( $settings['StatusImage'] && file_exists($DOCUMENT_ROOT.$imagesPath.$settings['StatusImage']) ) $IMG_STATUS = true; else $IMG_STATUS = false;
	if( $settings['PrevImage'] && file_exists($DOCUMENT_ROOT.$imagesPath.$settings['PrevImage']) ) $IMG_PREV_MONTH = true; else $IMG_PREV_MONTH = false;
	if( $settings['NextImage'] && file_exists($DOCUMENT_ROOT.$imagesPath.$settings['NextImage']) ) $IMG_NEXT_MONTH = true; else $IMG_NEXT_MONTH = false;
	
	$CalendarHeader = str_replace("%SELECT_MONTH", $month_select, $settings['CalendarHeader']);
	$CalendarHeader = str_replace("%SELECT_YEAR", $year_select, $CalendarHeader);
	
	$CalendarHeader = str_replace("%MONTH_NAME", $MonthArray[(int)$month], $CalendarHeader);
	$CalendarHeader = str_replace("%MONTH_DIGIT", $month, $CalendarHeader);
	$CalendarHeader = str_replace("%YEAR_DIGIT", $year, $CalendarHeader);
		
	$CalendarHeader = str_replace("%IMG_STATUS", ($IMG_STATUS ? "<img src='".$imagesPath.$settings['StatusImage']."' style='display:none;' id='ImgWaiting' alt='waiting' title='waiting'>" : ""), $CalendarHeader);

	$CalendarHeader = str_replace("%IMG_PREV_MONTH", ($IMG_PREV_MONTH ? "<img src='".$imagesPath.$settings['PrevImage']."' onclick='nc_calendar_generate(".($day ? $day : 1).", ".($month==1 ? 12 : $month-1).", ".($month==1 ? $year-1 : $year)."); return false;' alt='".$MonthArray[$month==1 ? 12 : $month-1]."' title='".$MonthArray[$month==1 ? 12 : $month-1]."'>" : "&lt;"), $CalendarHeader);
	$CalendarHeader = str_replace("%MONTH_LINK", ($DateFieldExist ? "<a href='".$Hidden_URL.$year."/".sprintf("%02d", $month)."/'>" : "").$MonthArray[(int)$month].($DateFieldExist ? "</a>" : ""), $CalendarHeader);
	$CalendarHeader = str_replace("%YEAR_LINK", ($DateFieldExist ? "<a href='".$Hidden_URL.$year."/'>" : "").sprintf("%04d", $year).($DateFieldExist ? "</a>" : ""), $CalendarHeader);
	$CalendarHeader = str_replace("%IMG_NEXT_MONTH", ($IMG_NEXT_MONTH ? "<img src='".$imagesPath.$settings['NextImage']."' onclick='nc_calendar_generate(".($day ? $day : 1).", ".($month==12 ? 1 : $month+1).", ".($month==12 ? $year+1 : $year)."); return false;' alt='".$MonthArray[$month==12 ? 1 : $month+1]."' title='".$MonthArray[$month==12 ? 1 : $month+1]."'>" : "&gt;"), $CalendarHeader);
	
	if(!$setDate) {
		$calendarBlockBegin = "<div id='nc_calendar_block'>";
		$calendarBlockEnd = "</div>\r\n<input type='hidden' id='calendar_cc' value='".$cc."'>\r\n<input type='hidden' id='calendar_theme' value='".$theme."'>\r\n<input type='hidden' id='calendar_field' value='".$DateField."'>\r\n<input type='hidden' id='calendar_filled' value='".$filled."'>\r\n";
	}
		
	# , html- 
	$result = $calendarBlockBegin.$settings['CalendarPrefix'].$CalendarHeader.$calendarBody.$settings['CalendarSuffix'].$calendarBlockEnd;
	
return $result;
}


/**
  *     MessageXX  $DateField
  * @param int  
  * @param string  
  * @return bool
  */
function nc_calendar_possibility_check($classID, $DateField = "Date") {
global $db;

	$classID = (int)$classID;
	$DateField = $db->escape($DateField);
	
	if(!$classID || !$DateField) return false;
	
	$table_exist = $db->get_var("SHOW TABLES LIKE 'Message".$classID."'");
	if (!$table_exist) return false;
	$result = $db->get_var("SHOW COLUMNS FROM `Message".$classID."` LIKE '".$DateField."'");

return $result;
}
?>