<?

/* $Id: system.inc.php 1957 2008-04-10 07:21:53Z vadim $ */

####################################
#     
####################################

function ColumnInMessage ($FieldID, $type, $db)
{
    global $SystemTableID, $db;

    # $type description:
    # 1 - add
    # 2 - modify
    # 3 - drop

    $SystemTableID = $db->get_var("SELECT System_Table_ID FROM Field WHERE Field_ID=".$FieldID) ;

    $TableName = GetSystemTableName($SystemTableID);

    list($FieldName,$TypeOfDataID,$NotNull,$DefaultState) = $db->get_row("select Field_Name,TypeOfData_ID,NotNull,DefaultState from Field where Field_ID=".$FieldID,ARRAY_N);

    switch ($type) {
        case 1: $oper = "add"; break;
        case 2: $oper = "modify"; break;
        case 3: $oper = "drop"; break;
    }

    $alter = "alter table ".$TableName." ".$oper." ".$FieldName;

    if ($type==3) {
        $AlterResult = $db->query($alter) ;
        return true;
    }

    $alter .= " ";

    switch ($TypeOfDataID) {
        case 1: $alter .= "char(255)"; break;
        case 2: $alter .= "int"; break;
        case 3: $alter .= "text"; break;
        case 4: $alter .= "int"; break;
        case 5: $alter .= "tinyint"; break;
        case 6: $alter .= "char(255)"; break;
        case 7: $alter .= "double"; break;
        case 8: $alter .= "datetime"; break;
    }

    if ($DefaultState!="" && $TypeOfDataID!=3)
    {
        $alter.= " NOT NULL DEFAULT '$DefaultState'";
    }
    else
    {
        if ($NotNull)
        {
            $alter.= " NOT NULL";
        }
        else
        {
            $alter.= " NULL";
        }
    }
    $AlterResult = $db->query($alter);
    return true;
}

#######################################
#    
#######################################
function FieldList ($SystemTableID)
{
    global $db;
    global $UI_CONFIG, $ADMIN_PATH, $ADMIN_TEMPLATE;

    $Result = $db->get_results("SELECT Field_ID, Field_Name, Description, TypeOfData_ID, DoSearch, NotNull, TypeOfEdit_ID, Priority FROM Field WHERE System_Table_ID=".$SystemTableID." ORDER BY Priority");
    
    if ($countFields=$db->num_rows)
    {
        ?>
        <form method=post action="systemField.php">
        <table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>
        <table border=0 cellpadding=4 cellspacing=1 width=100%>
        <tr>
        <td bgcolor=eeeeee><font size=-2><b>ID</td>
        <td bgcolor=eeeeee width=40%><font size=-2><b><?=CONTROL_FIELD_LIST_NAME?></td>
        <td bgcolor=eeeeee width=40%><font size=-2><b><?=CONTROL_FIELD_LIST_DESCRIPTION?></td>
        <td bgcolor='eeeeee' colspan='4' width=10%><font size=-2><b><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_DOPL?></b></font></td>
        <td bgcolor=eeeeee align=center><img width=16 height=16 src=<?=$ADMIN_PATH?>images/prior.gif alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_PRIORITY?>'></td>
        <td bgcolor=eeeeee align=center><img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DELETE?>'></td>
        </tr>
        <?

        $field_types = array(1 => 'i_type_string.gif',
                             2 => 'i_type_int.gif',
                             3 => 'i_type_text.gif',
                             4 => 'i_type_classificator.gif',
                             5 => 'i_type_bool.gif',
                             6 => 'i_type_file.gif',
                             7 => 'i_type_float.gif',
                             8 => 'i_type_date.gif');

        $field_type_name = array(1 => CLASSIFICATOR_TYPEOFDATA_STRING,
                                 2 => CLASSIFICATOR_TYPEOFDATA_INTEGER,
                                 3 => CLASSIFICATOR_TYPEOFDATA_TEXTBOX,
                                 4 => CLASSIFICATOR_TYPEOFDATA_LIST,
                                 5 => CLASSIFICATOR_TYPEOFDATA_BOOLEAN,
                                 6 => CLASSIFICATOR_TYPEOFDATA_FILE,
                                 7 => CLASSIFICATOR_TYPEOFDATA_FLOAT,
                                 8 => CLASSIFICATOR_TYPEOFDATA_DATETIME,
                                 9 => CLASSIFICATOR_TYPEOFDATA_RELATION);

        $type_of_edit = array(1 => 'i_field_access_all.gif',
                              2 => 'i_field_access_admin.gif',
                              3 => 'i_field_access_no.gif');

        $type_of_edit_name = array(1 => CLASSIFICATOR_TYPEOFEDIT_ALL,
                                   2 => CLASSIFICATOR_TYPEOFDATA_ADMINS,
                                   3 => CLASSIFICATOR_TYPEOFDATA_NOONE);

        foreach ( $Result as $Row )
        {
            print "<tr>";
 		    print "<td bgcolor=white><font size=-2><b>".$Row->Field_ID."</td>";
 		    print "<td bgcolor=white><a href=\"systemField.php?phase=4&FieldID=".$Row->Field_ID."\">".$Row->Field_Name."</a></td>";
 		    print "<td bgcolor=white><font size=-2>".$Row->Description."</td>";
 		    print "<td bgcolor=white><img src='".$ADMIN_TEMPLATE."img/".$field_types[$Row->TypeOfData_ID]."' alt='".$field_type_name[$Row->TypeOfData_ID]."'></td>";
 		    print "<td bgcolor=white><img src='".$ADMIN_TEMPLATE."img/i_field_search_".($Row->DoSearch?"on":"off").".gif' alt='".CONTROL_FIELD_ONE_INDEX."'</td>";
 		    print "<td bgcolor=white><img src='".$ADMIN_TEMPLATE."img/i_field_notnull_".($Row->NotNull?"on":"off").".gif' alt='".CONTROL_FIELD_ONE_MUSTBE."'</td>";
 		    print "<td bgcolor=white><img src='".$ADMIN_TEMPLATE."img/".$type_of_edit[$Row->TypeOfEdit_ID]."' alt='".$type_of_edit_name[$Row->TypeOfEdit_ID]."'</td>";
 		    print "<td align=center bgcolor=white><input type=text name=priority[".$Row->Field_ID."] value='".($Row->Priority?$Row->Priority:0)."' size=3 class=s maxlength=5></td>";
 		    print "<td align=center bgcolor=white><input type='checkbox' name='Delete[]' VALUE=".$Row->Field_ID."></td>\n";
            print "</tr>";
        }
        print "<input type='hidden' name='SystemTableID' value='".$SystemTableID."'>\n";
        ?>
            </table>
            </td></tr></table>
        <?
    } else {
      echo CONTROL_FIELD_MSG_NONE_TABLE.".<br><br>";
    }
    if ($countFields) {
      $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                          "caption" => CONTROL_FIELD_LIST_CHANGE,
                                          "action" => "mainView.submitIframeForm()"
                                         );
    }
    $UI_CONFIG->actionButtons[] = array("id" => "addClass",
                                        "caption" => CONTROL_FIELD_LIST_ADD,
                                        "action" => "urlDispatcher.load('systemfield.add($SystemTableID)')",
                                        "align" => "left");
    if ($countFields) {
        ?>
        <input type=hidden name=phase VALUE=6>
		<input type='submit' class='hidden'>
        </form>
        <?
    }
}

#########################################
#        
#########################################

function FieldForm ($FieldID, $SystemTableID)
{
    global $db;
	global $UI_CONFIG;

    if ($FieldID)
    {
        $Array = $db->get_row("select Field_Name, Description, TypeOfData_ID, Format, NotNull, Priority, Inheritance, DefaultState, TypeOfEdit_ID from Field where Field_ID=".$FieldID,ARRAY_A) ;
    }
    else
    {
        $res = $db->get_var("SELECT (Priority+1) FROM Field WHERE System_Table_ID=".$SystemTableID." ORDER BY Priority DESC LIMIT 1");
        if (!is_null($res))
        {
            $Array["Priority"] = $res;
        }
    }

    print "<FORM METHOD=POST ACTION=systemField.php><font color=gray>";

    if ($FieldID)
    {
        print CONTROL_FIELD_LIST_NAME.": <b>".$Array["Field_Name"]."</b><br><br>";
    }
    else
    {
        print CONTROL_FIELD_LIST_NAMELAT.":<br><INPUT TYPE=TEXT NAME=FieldName SIZE=50 MAXLENGTH=64 value='".htmlspecialchars($Array["Field_Name"])."'><br><br>";
    }

    print CONTROL_FIELD_LIST_DESCRIPTION.":<br><INPUT TYPE=TEXT NAME=Description SIZE=50 MAXLENGTH=64 value='".htmlspecialchars($Array["Description"])."'><br><br>";

    print CONTROL_FIELD_ONE_FTYPE.":<br><SELECT NAME=TypeOfDataID>";
    print "<OPTION ".($Array["TypeOfData_ID"]==1?"selected":"")." VALUE=1>1: ".CLASSIFICATOR_TYPEOFDATA_STRING;
    print "<OPTION ".($Array["TypeOfData_ID"]==2?"selected":"")." VALUE=2>2: ".CLASSIFICATOR_TYPEOFDATA_INTEGER;
    print "<OPTION ".($Array["TypeOfData_ID"]==3?"selected":"")." VALUE=3>3: ".CLASSIFICATOR_TYPEOFDATA_TEXTBOX;
    print "<OPTION ".($Array["TypeOfData_ID"]==4?"selected":"")." VALUE=4>4: ".CLASSIFICATOR_TYPEOFDATA_LIST;
    print "<OPTION ".($Array["TypeOfData_ID"]==5?"selected":"")." VALUE=5>5: ".CLASSIFICATOR_TYPEOFDATA_BOOLEAN;
    print "<OPTION ".($Array["TypeOfData_ID"]==6?"selected":"")." VALUE=6>6: ".CLASSIFICATOR_TYPEOFDATA_FILE;
    print "<OPTION ".($Array["TypeOfData_ID"]==7?"selected":"")." VALUE=7>7: ".CLASSIFICATOR_TYPEOFDATA_FLOAT;
    print "<OPTION ".($Array["TypeOfData_ID"]==8?"selected":"")." VALUE=8>8: ".CLASSIFICATOR_TYPEOFDATA_DATETIME;
    print "</SELECT><br><br>";

    print CONTROL_FIELD_ONE_FORMAT.":<br><INPUT TYPE=TEXT NAME=Format SIZE=50 MAXLENGTH=255 value='".htmlspecialchars($Array["Format"], ENT_QUOTES)."'><br><br>";

    print "<input id=notn type=checkbox ".($Array["NotNull"]?"checked":"")." name=NotNull value=1> <label for=notn>".CONTROL_FIELD_ONE_MUSTBE."</label><br>";
    print "<input id=inhr type=checkbox ".($Array["Inheritance"]?"checked":"")." name=Inheritance value=1> <label for=inhr>".CONTROL_FIELD_ONE_INHERITANCE."</label><br><br>";

    print CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_PRIORITY.": <INPUT TYPE=TEXT NAME=Priority SIZE=3 MAXLENGTH=5 value='".($Array["Priority"]+0)."'><br><br>";

    print CONTROL_FIELD_ONE_DEFAULT."*:<br>";
    print "<INPUT TYPE=TEXT NAME=DefaultState SIZE=50 MAXLENGTH=255 value='".htmlspecialchars($Array["DefaultState"])."'><br>* ".CONTROL_FIELD_ONE_DEFAULT_NOTE.".<br><br>";

    print "<table border=0 cellpadding=6 cellspacing=0 width=100%>";

    print "<TR><TD valign=top width=30%><font color=gray>".CONTROL_FIELD_ONE_ACCESS.":</td><td>";

    if ($Array["TypeOfEdit_ID"]=="")
    {
        $Array["TypeOfEdit_ID"] = 1;
    }

    echo "<input type=radio name=TypeOfEdit_ID ";
    if ($Array["TypeOfEdit_ID"] == 1)
    {
        print "checked ";
    }
    print "VALUE=1 id=mod1> <label for=mod1>".CLASSIFICATOR_TYPEOFEDIT_ALL."</label><br>";

    echo "<input type=radio name=TypeOfEdit_ID ";
    if ($Array["TypeOfEdit_ID"] == 2)
    {
        print "checked ";
    }
    print "VALUE=2 id=mod2> <label for=mod2>".CLASSIFICATOR_TYPEOFDATA_ADMINS."</label><br>";

    echo "<input type=radio name=TypeOfEdit_ID ";
    if ($Array["TypeOfEdit_ID"] == 3)
    {
        print "checked ";
    }
    print "VALUE=3 id=mod3> <label for=mod3>".CLASSIFICATOR_TYPEOFDATA_NOONE."</label><br>";

    print "</SELECT></TD></TR>\n\n";
    print "</table>";

    if (!$FieldID)
    {
//        echo "<input class=s type=submit value='".CONTROL_FIELD_LIST_ADD."'>";
      $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                          "caption" => CONTROL_FIELD_LIST_ADD,
                                          "action" => "mainView.submitIframeForm()");
    }
    else
    {
//      echo "<input class=s type=reset value='".CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL."'> <input class=s type=submit value='".CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE."'>";
      $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                          "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
                                          "action" => "mainView.submitIframeForm()");
    }

    ?>
    </div>
    <?

    if (!$FieldID)
    {
        print "<INPUT TYPE=HIDDEN NAME=SystemTableID VALUE=".$SystemTableID.">";
        print "<input type=hidden name=phase value=3>";
    }
    else
    {
        print "<INPUT TYPE=HIDDEN NAME=SystemTableID VALUE=".$SystemTableID.">";
        print "<INPUT TYPE=HIDDEN NAME=FieldID VALUE=".$FieldID.">";
        print "<input type=hidden name=phase value=5>";
    }

    print "<input type='submit' class='hidden'>";
    print "</form>";


}

#######################################################
#        
#################################################

function FieldCompleted ()
{
    global $db,$FieldID,$SystemTableID,$FieldName,$Description,$TypeOfDataID,$TypeOfEdit_ID,$Format,$NotNull,$Priority,$Inheritance,$DefaultState;

    $TableName = GetSystemTableName ($SystemTableID);

    $NotNull += 0;
    $Inheritance += 0;
    $Priority += 0;

    if (!$FieldID)
    {
        require_once("$GLOBALS[ADMIN_FOLDER]field/reserved.inc.php");

        // ,    ,  
        if ( $SelectResult = $db->get_results("show fields from ".$TableName." like '".$FieldName."'") )
        {
            return false;
        }
        else if (preg_match('/\\b\\d+\\b/', str_replace(" ","",$FieldName)))
        {
            return false;
        }
        // check for reserved sql words
        else if (nc_is_mysql_keyword($FieldName))
        {
           return false;
        }
        else
        {
            if ($inserted = $db->query("insert into Field (System_Table_ID,Field_Name,Description,TypeOfData_ID,Format,NotNull,Priority,Inheritance,DefaultState,TypeOfEdit_ID) values (".$SystemTableID.",'".$FieldName."','".$Description."',".$TypeOfDataID.",'".$Format."',".$NotNull.",".$Priority.",".$Inheritance.",'".$DefaultState."','".$TypeOfEdit_ID."')"))
            {
                $CurrentFieldID = $db->insert_id ;
                ColumnInMessage ($CurrentFieldID, 1, $db);
            }
        }
        return $CurrentFieldID;
    }
    //   ,       
    else
    {
        if ($updated = $db->query("update Field set Description='".$Description."',TypeOfData_ID=".$TypeOfDataID.",Format='".$Format."',NotNull=".$NotNull.",Priority=".$Priority.",Inheritance=".$Inheritance.",DefaultState='".$DefaultState."',TypeOfEdit_ID='".$TypeOfEdit_ID."' where Field_ID=".$FieldID))
        {
            ColumnInMessage ($FieldID, 2, $db);
        }
    }
    return $FieldID;
}

######################################################
#   ,     
######################################################

function UpdateFieldPriority($priority) {
	global $db;

	if ( is_array($priority) && !empty($priority) ) {
		foreach($priority AS $key => $val) {
			$db->query("UPDATE `Field` SET `Priority` = '".(int)$val."' WHERE `Field_ID` = '".(int)$key."'");
		}
	}

	return true; 
}


function confirm_fields_removal($system_fields, $system_table_id) {
  
  global $db, $UI_CONFIG;
  global $priority;
  
  $system_fields_array = $db->get_results("SELECT Field_ID, Field_Name, Description, TypeOfData_ID FROM Field WHERE Field_ID IN (".join(',', $system_fields).")", ARRAY_A);

  if ($db->num_rows > 1) {
    nc_print_status(CONTROL_FIELD_MSG_CONFIRM_REMOVAL_MANY, 'info');
  } else {
    nc_print_status(CONTROL_FIELD_MSG_CONFIRM_REMOVAL_ONE, 'info');
  }
  
  echo "<form method='post' action='systemField.php'>";
  echo "<input type='hidden' name='phase' value='7'>";
  echo "<input type='hidden' name='SystemTableID' value='".$system_table_id."'>";
  echo "<ul>";
  
  foreach ($system_fields_array as $system_field) {
    echo "<li>".$system_field['Field_Name']." (".$system_field['Description'].")<input type='hidden' name='Delete[]' value='".$system_field['Field_ID']."'>";
  }
  
  echo "</ul>";
  if ($priority) foreach ($priority as $key => $val) echo "<input type='hidden' name='priority[$key]' value='".$val."'>\n";
  echo "</form>";
  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => CONTROL_FIELD_CONFIRM_REMOVAL,
                                      "action" => "mainView.submitIframeForm()");
}


##########################################
#  ,     
##########################################

function DeleteFields ($system_fields)
{
  global $db, $UI_CONFIG;

  $deleted_system_fields = 0;

  foreach ($system_fields as $system_field) {
    if (ColumnInMessage($system_field, 3, $db)) {
      $db->query("DELETE FROM Field WHERE Field_ID=".$system_field);
      if ($db->rows_affected) {
        $deleted_system_fields++;
        $UI_CONFIG->treeChanges['deleteNode'][] = "systemfield-".$system_field;
      }
    }
  }
  
  return $deleted_system_fields;

/*
    foreach ($_POST as $key => $val) {
        if (substr($key,0,6)=="Delete" && $val)
        {
            if (!$system_table_id) $system_table_id = $db->get_var("SELECT System_Table_ID FROM Field WHERE Field_ID = ".$val);
            $val += 0;
            ColumnInMessage ($val, 3, $db);
            $db->query("DELETE FROM Field WHERE Field_ID=".$val);
        }
    }
    foreach ($_GET as $key => $val) {
        if (substr($key,0,6)=="Delete" && $val)
        {
            if (!$system_table_id) $system_table_id = $db->get_var("SELECT System_Table_ID FROM Field WHERE Field_ID = ".$val);
            $val += 0;
            ColumnInMessage ($val, 3, $db);
            $db->query("DELETE FROM Field WHERE Field_ID=".$val);
        }
    }
    return array($system_table_id, $val);
*/
}

class ui_config_system_field extends ui_config {

  function ui_config_system_field($active_tab = 'edit', $system_field_id, $system_class_id) {

    global $db;

    $this->headerImage = 'i_folder_big.gif';
    if ($active_tab == 'add') {
	  $this->tabs = array(
		                 array('id' => 'add',
	                           'caption' => CONTROL_FIELD_ADDING,
	                           'location' => "systemfield.add($system_class_id)")
		          );
	  $this->headerText = constant($db->get_var("SELECT System_Table_Rus_Name FROM System_Table WHERE System_Table_ID = '$system_class_id'"));
//	  $this->treeSelectedNode = "systemclass-{$system_class_id}";
    } elseif ($active_tab == 'edit') {
	  $this->tabs = array(
		                 array('id' => 'edit',
	                           'caption' => CONTROL_FIELD_EDITING,
	                           'location' => "systemfield.edit($system_field_id)")
		          );
	  $this->headerText = $db->get_var("SELECT Description FROM Field WHERE Field_ID = '$system_field_id'");
      $this->treeSelectedNode = "systemfield-{$system_field_id}";
    } elseif ($active_tab == 'delete') {
	  $this->tabs = array(
		                 array('id' => 'delete',
	                           'caption' => CONTROL_FIELD_DELETING,
	                           'location' => "systemfield.delete($system_class_id,$system_field_id)")
		          );
	  $this->headerText = constant($db->get_var("SELECT System_Table_Rus_Name FROM System_Table WHERE System_Table_ID = '$system_class_id'"));
	  $this->treeSelectedNode = "systemclass-{$system_class_id}";
    }

    $this->activeTab = $active_tab;
    $this->treeMode = 'developer';

  }

  function updateTreeSystemFieldNode($system_field_id, $system_field_type) {
    $field_types = array(1 => 'i_type_string.gif',
                         2 => 'i_type_int.gif',
                         3 => 'i_type_text.gif',
                         4 => 'i_type_classificator.gif',
                         5 => 'i_type_bool.gif',
                         6 => 'i_type_file.gif',
                         7 => 'i_type_float.gif',
                         8 => 'i_type_date.gif');
    $this->treeChanges['updateNode'][] = array("nodeId" => "systemfield-$system_field_id",
                                               "image" => $field_types[$system_field_type]);
  }

}

###############################################################################
?>