<?
$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");
require ($ADMIN_FOLDER."class/function.inc.php");
require ($ADMIN_FOLDER."field/system.inc.php");

if ( !isset($SystemTableID) )
{
    $SystemTableID=GetSystemTableIDByFieldID ($FieldID);
}

$Delimeter = " &gt ";
$main_section = "settings";
$item_id = 1;
$Title1 = "<a href=\"".$ADMIN_PATH."field/system.php\">".SECTION_SECTIONS_OPTIONS_SYSTEM."</a>";
$Title2 = CONTROL_FIELD_FIELDS." (".GetSystemTableRusName ($SystemTableID).")";
$Title3 = "<a href=\"".$ADMIN_PATH."field/systemField.php?SystemTableID=".$SystemTableID."\">".CONTROL_FIELD_FIELDS." (".GetSystemTableRusName ($SystemTableID).")</a>";
$Title4 = CONTROL_FIELD_ADDING;
$Title5 = GetFieldName ($FieldID);
$Title6 = CONTROL_FIELD_EDITING;

if (! ($perm->isSupervisor() || $perm->isGuest()) )
{
    BeginHtml ($Title0, $Title1.$Delimeter.$Title2, "");
    nc_print_status($NO_RIGHTS_MESSAGE, 'error');
    EndHtml ();
    exit;
}

if (!isset($phase))
{
    $phase=1;
}

//$UI_CONFIG = new ui_config_system_field('edit', $FieldID);

switch ($phase) {

    case 1:
        #    
        BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/settings/systables/fields/");
        $UI_CONFIG = new ui_config_system_class('fields', $SystemTableID);
        FieldList ($SystemTableID);
        break;

    case 2:
        #    
        $UI_CONFIG = new ui_config_system_field('add', 0, $SystemTableID);
        BeginHtml ($Title4, $Title1.$Delimeter.$Title3.$Delimeter.$Title4, "http://".$DOC_DOMAIN."/settings/systables/fields/form/");
        FieldForm (0, $SystemTableID);
        break;

    case 3:
        #      
        BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/settings/systables/fields/");
        $perm->ExitIfGuest ();

        if (!preg_match("/^[a-zA-Z0-9_]+$/", $FieldName))
        {
			nc_print_status(CONTROL_FIELD_NAME_ERROR, 'error');
			FieldForm (0, $SystemTableID);
        }
        else
        {
			$new_field_id = FieldCompleted();
			if ($new_field_id)
			{
				$UI_CONFIG = new ui_config_system_class('fields', $SystemTableID);
                $field_types = array(1 => 'i_type_string.gif',
                                     2 => 'i_type_int.gif',
                                     3 => 'i_type_text.gif',
                                     4 => 'i_type_classificator.gif',
                                     5 => 'i_type_bool.gif',
                                     6 => 'i_type_file.gif',
                                     7 => 'i_type_float.gif',
                                     8 => 'i_type_date.gif',
                                     9 => 'i_type_link.gif');

				FieldList ($SystemTableID);

                $system_field = $db->get_row("SELECT field.Field_ID, field.Field_Name, field.TypeOfData_ID FROM Field AS field LEFT JOIN Classificator_TypeOfData AS type ON type.TypeOfData_ID = field.TypeOfData_ID WHERE field.Field_ID = '".$new_field_id."' ORDER BY field.Priority", ARRAY_A);

                $system_field_buttons[] = array("image" => "i_field_delete.gif",
        		                                "label" => CONTROL_FIELD_LIST_DELETE,
                		                        "href" => "systemfield.delete(".$SystemTableID.",".$new_field_id.")");

                $UI_CONFIG->treeChanges['addNode'][] = array("nodeId" => "systemfield-$new_field_id",
                                 "parentNodeId" => "systemclass-".$SystemTableID, 
                                 "name" => $new_field_id.". ".$system_field["Field_Name"],
                                 "href" => "#systemfield.edit($new_field_id)",
                                 "image" => $field_types[$system_field["TypeOfData_ID"]],
                                 "buttons" => $system_field_buttons,
                                 "acceptDropFn" => "treeSystemFieldAcceptDrop",
                                 "onDropFn" => "treeSystemFieldOnDrop",
                                 "hasChildren" => false,
                                 "dragEnabled" => true,
                                 "parentMustBeLoaded" => true);

			}
			else
			{
				nc_print_status(CONTROL_FIELD_ONE_RESERVED, 'error');
            	FieldForm (0, $SystemTableID);
			}
        }
        break;

    case 4:
        #    
        $UI_CONFIG = new ui_config_system_field('edit', $FieldID, $SystemTableID);
        BeginHtml ($Title6, $Title1.$Delimeter.$Title3.$Delimeter.$Title5, "http://".$DOC_DOMAIN."/settings/systables/fields/form/");
        FieldForm ($FieldID, $SystemTableID);
        break;

    case 5:
        #   
        BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/settings/systables/fields/");
        $perm->ExitIfGuest ();
        FieldCompleted ();
        nc_print_status(CONTROL_FIELD_MSG_EDITED, 'ok');
        $UI_CONFIG = new ui_config_system_field('edit', $FieldID, 0);
        $UI_CONFIG->updateTreeSystemFieldNode($FieldID, $TypeOfDataID);
	   FieldForm ($FieldID, $SystemTableID);
        break;

    case 6:
        #      
        BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/management/class/fields/");
        $perm->ExitIfGuest();
        if ($Delete) {
          $UI_CONFIG = new ui_config_system_field('delete', 0, $SystemTableID);
          confirm_fields_removal($Delete, $SystemTableID);
        } else {
          $UI_CONFIG = new ui_config_system_class('fields', $SystemTableID);
          UpdateFieldPriority($priority);
          nc_print_status(CONTROL_FIELD_MSG_FIELDS_CHANGED, 'ok');
          FieldList($SystemTableID);
        }
    break;
        
	case 7:
        #     
        BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/settings/systables/fields/");
        $perm->ExitIfGuest ();
        $UI_CONFIG = new ui_config_system_class('fields', $SystemTableID);
        UpdateFieldPriority($priority);
        if (DeleteFields($Delete) > 1) {
          nc_print_status(CONTROL_FIELD_MSG_DELETED_MANY, 'ok');
        } else {
          nc_print_status(CONTROL_FIELD_MSG_DELETED_ONE, 'ok');
        }
        FieldList($SystemTableID);
	break;
/*
    case 6:
        #     
        BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/settings/systables/fields/");
        $perm->ExitIfGuest ();
        UpdateFieldPriority();
        list($SystemTableID, $FieldID) = DeleteFields ();

    	$UI_CONFIG = new ui_config_system_class('fields', $SystemTableID);
        nc_print_status(CONTROL_FIELD_MSG_DELETED, 'ok');
        $UI_CONFIG->treeChanges['deleteNode'][] = "systemfield-{$FieldID}";
        FieldList ($SystemTableID);
        break;
*/
}
EndHtml ();
?>